﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight.Data;
using C1.Silverlight;
using C1.Silverlight.Chart;
using System.Windows.Data;

namespace SL_Flex_HyperLinkColumnChartData
{
    public partial class MainPage : UserControl
    {       

        public MainPage()
        {
            InitializeComponent();
            
            c1FlexGrid1.ItemsSource = ParentTable().DefaultView;            
        }

        public DataTable ParentTable()
        { 
            DataTable EmployeeTable = new DataTable();
            EmployeeTable.Name = "Employee";
            EmployeeTable.Columns.Add(new DataColumn("EmployeeID", typeof(Int32)));
            EmployeeTable.Columns.Add(new DataColumn("EmployeeName", typeof(string)));
            EmployeeTable.Columns.Add(new DataColumn("EmployeeCity", typeof(string)));
            EmployeeTable.Columns.Add(new DataColumn("EmployeeDate", typeof(DateTime)));


            DataRow dr = EmployeeTable.NewRow();
            dr.ItemArray = new object[] { 231, "John", "London", DateTime.Now.AddDays(new Random().Next(0, 300)) };
            EmployeeTable.Rows.Add(dr);

            dr = EmployeeTable.NewRow();
            dr.ItemArray = new object[] { 232, "James", "Berlin", DateTime.Now.AddDays(new Random().Next(0, 300)) };
            EmployeeTable.Rows.Add(dr);


            dr = EmployeeTable.NewRow();
            dr.ItemArray = new object[] { 233, "Lina", "Washington D.C.", DateTime.Now.AddDays(new Random().Next(0, 300)) };
            EmployeeTable.Rows.Add(dr);

            dr = EmployeeTable.NewRow();
            dr.ItemArray = new object[] { 234, "David", "London", DateTime.Now.AddDays(new Random().Next(0, 300)) };
            EmployeeTable.Rows.Add(dr);

            dr = EmployeeTable.NewRow();
            dr.ItemArray = new object[] { 235, "Michael", "Moscow", DateTime.Now.AddDays(new Random().Next(0, 300)) };
            EmployeeTable.Rows.Add(dr);

            return EmployeeTable;
        }

        public DataTable ChildTable()
        {
            DataTable SalesTable = new DataTable();
            SalesTable.Name = "Sales";
            SalesTable.Columns.Add(new DataColumn("EmployeeID", typeof(Int32)));
            SalesTable.Columns.Add(new DataColumn("Region", typeof(string)));
            SalesTable.Columns.Add(new DataColumn("SalesAmount", typeof(Int32)));

            DataRow dr = SalesTable.NewRow();

            dr.ItemArray = new object[] { 231, "North", 100000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 231, "East", 150000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 231, "West", 165000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 231, "South", 200000 };
            SalesTable.Rows.Add(dr);


            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 232, "North", 200000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 232, "East", 175000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 232, "West", 155000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 232, "South", 200000 };
            SalesTable.Rows.Add(dr);


            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 233, "North", 200000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 233, "East", 185000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 233, "West", 165000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 233, "South", 150000 };
            SalesTable.Rows.Add(dr);


            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 234, "North", 250000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 234, "East", 150000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 234, "West", 195000 };
            SalesTable.Rows.Add(dr);

            dr = SalesTable.NewRow();
            dr.ItemArray = new object[] { 234, "South", 200000 };
            SalesTable.Rows.Add(dr);
            
            return SalesTable;        
        }

        private void HyperlinkButton_Click(object sender, RoutedEventArgs e)
        {
            int rowIndex = Grid.GetRow((e.OriginalSource as HyperlinkButton).Parent as Border);
            int CustId = (int)(c1FlexGrid1.Rows[rowIndex].DataItem as DataRowView).GetData("EmployeeID");
            ShowChart(CustId);
        }

        public void ShowChart(int empID)    
        {

            C1Window wnd = new C1Window();
            wnd.Header = "Sales Report";
            wnd.Height = 300;
            wnd.Width = 300;

            C1.Silverlight.Chart.C1Chart _c1Chart = new C1.Silverlight.Chart.C1Chart();
            wnd.Content = _c1Chart;

            // Clear current chart
            _c1Chart.Reset(true);


            // Set chart type
            _c1Chart.ChartType =  C1.Silverlight.Chart.ChartType.Column;

            // Get axes
            Axis valueAxis = _c1Chart.View.AxisY;
            Axis labelAxis = _c1Chart.View.AxisX;


            // Configure label axis
            labelAxis.Title = new TextBlock() { Text = "Region", FontSize = 14, FontWeight  = FontWeights.Bold };
            labelAxis.AutoMin = true;
            labelAxis.AnnoAngle = 45;

            // Configure value axis
            valueAxis.Title = new TextBlock() { Text = " Sales Amount ($)", FontSize = 14, FontWeight = FontWeights.Bold };
            valueAxis.AutoMin = false;
            valueAxis.Min = 0;
            

            // Get the data

            DataView dv = ChildTable().DefaultView;
            dv.RowFilter = "EmployeeID = " + empID.ToString();           

            _c1Chart.Data.ItemsSource = dv;
                        
            // Show Product Name along x axis
            _c1Chart.Data.ItemNameBinding = new Binding("Region");
            

            // Add data series
            var ds = new DataSeries();
            ds.Label = "Unit Price";
            ds.ValueBinding = new Binding("SalesAmount");
            _c1Chart.Data.Children.Add(ds);

            wnd.ShowModal();
            wnd.CenterOnScreen();
        }

    }

    
}
